/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package isac.gui.mawen;

import isac.bridge.CalcIterator;
import isac.interfaces.ICalcIterator;
import isac.interfaces.IToCalc;
import isac.interfaces.IToGUI;
import isac.interfaces.IToUser;
import isac.useractions.EUIContext;
import isac.useractions.EUIElement;
import isac.useractions.IUIAction;
import isac.useractions.IUserAction;
import isac.useractions.UIAction;
import isac.useractions.UIActionOnCalcElement;
import isac.users.UserLanguage;
import isac.users.UserLanguage.LanguageName;
import isac.util.CalcChanged;
import isac.util.formulae.CalcFormula;
import isac.util.formulae.Position;
import isac.wsdialog.DialogProtocolException;
import isac.wsdialog.IWorksheetDialog;

import java.rmi.RemoteException;
import java.util.Vector;

/**
 * @author Natalie Karl
 */
public class MockWorksheetDialog implements IWorksheetDialog{

    private boolean worksheet_ready_;
    private Vector<IToUser> datachange_listeners_ = new Vector<IToUser>();
	private IToGUI ui_control_listener_;
	private UserLanguage user_language_ = new UserLanguage("D:\\Userdata\\Nati\\Desktop\\WorkspaceMawen\\proto4\\repos\\xmldata\\users\\", LanguageName.ENGLISH);
	private CalcFormula context_formula_;

    protected ICalcIterator active_formula_;

	@Override
    public IToCalc getCalcTree() throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet."); 
    }

    @Override
    public void startCalculate() {
        //((CalcTree)calc_tree_).startCalculate();
    }

    @Override
    public boolean registerUIControlListener(IToGUI listener) {
        ui_control_listener_ = listener;
        buildUIElementsContextCalcElements();
        return true;
    }

    @Override
    public boolean notifyUserAction(IUserAction action)
        throws DialogProtocolException, RemoteException {
    
    EUIElement request = action.getActionID();

    switch (request) {
    case UI_CLOSE_WORKSHEET:
    
        return true;
    case UI_ACTIVE_WORKSHEET:
  
        return true;
      case LO_EXAMPLE_FINISHED_SUCCESSFUL:
        break;
      case LO_OPEN_WORKSHEET:
        break;
      case LO_START_SESSION:
        break;
      case UI_BROWSER_CHANGE_CONTEXT:
        break;
      case UI_BROWSER_EXECUTE_CONTEXT:
        break;
      case UI_BROWSER_GET_FOCUS:
        break;
      case UI_BROWSER_GOT_FOCUS:
        break;
      case UI_BROWSER_HIERARCHY:
        break;
      case UI_BROWSER_LOST_FOCUS:
        break;
      case UI_BROWSER_MATCH_OFF:
        break;
      case UI_BROWSER_MATCH_ON:
        break;
      case UI_BROWSER_TO_WORKSHEET:
        break;
      case UI_DO_ACTIVATE:
        break;
      case UI_DO_APPEND_FORMULA:
        break;
      case UI_DO_DEACTIVATE:
        break;
      case UI_DO_DETACH:
        break;
      case UI_DO_EDIT_FORMULA:
        break;
      case UI_DUMMY_FIRST_SOLVE:
        break;
      case UI_DUMMY_FIRST_SPECIFY:
        break;
      case UI_DUMMY_LAST_SOLVE:
        break;
      case UI_DUMMY_LAST_SPECIFY:
        break;
      case UI_MINIBROWSER_LINK:
        break;
      case UI_OPEN_BROWSER_FRAME:
        break;
      case UI_OPEN_WORKSHEET:
        break;
      case UI_PROBLEMBROWSER_REFINE:
        break;
      case UI_SHOW_EXAMPLE_BROWSER:
        break;
      case UI_SHOW_METHOD_BROWSER:
        break;
      case UI_SHOW_PROBLEM_BROWSER:
        break;
      case UI_SHOW_THEORY_BROWSER:
        break;
      case UI_SOLVE_APPEND_USER_FORMULA:
        break;
      case UI_SOLVE_CALCULATE_1:
        break;
      case UI_SOLVE_CALCULATE_ALL:
        break;
      case UI_SOLVE_CALCULATE_SUBPROBLEM:
        break;
      case UI_SOLVE_CHANGE_CONTEXT_FORMULA:
        break;
      case UI_SOLVE_EDIT_ACTIVE_FORMULA:
        break;
      case UI_SOLVE_EDIT_ACTIVE_FORMULA_COMPLETE:
        break;
      case UI_SOLVE_GET_APPLICABLE_TACTICS:
        break;
      case UI_SOLVE_GET_PROPOSED_TACTIC:
        break;
      case UI_SOLVE_HELP_ENTERING_FORMULA:
        break;
      case UI_SOLVE_MOVE_ACTIVE_FORMULA:
        break;
      case UI_SOLVE_SET_NEXT_TACTIC:
        break;
      case UI_SOLVE_SHOW_APPLICABLE_TACTICS:
        break;
      case UI_SOLVE_SHOW_ASSUMPTIONS:
        break;
      case UI_SOLVE_SHOW_CALCHEAD:
        break;
      case UI_SOLVE_SHOW_INTERMEDIATE_STEPS:
        break;
      case UI_SOLVE_TACTIC_APPLIED:
        break;
      case UI_SOLVE_TERM_TREE:
        break;
      case UI_SPECIFY_CALCULATE_ALL:
        break;
      case UI_SPECIFY_CHANGE_VIEW:
        break;
      case UI_SPECIFY_CHECK_CALCHEAD:
        break;
      case UI_SPECIFY_CLOSE_CALCHEAD:
        break;
      case UI_SPECIFY_COMPLETE_CALCHEAD:
        break;
      case UI_SPECIFY_COMPLETE_FIND:
        break;
      case UI_SPECIFY_COMPLETE_GIVEN:
        break;
      case UI_SPECIFY_COMPLETE_MODEL:
        break;
      case UI_SPECIFY_COMPLETE_RELATE:
        break;
      case UI_SPECIFY_COMPLETE_STEPWISE:
        break;
      case UI_SPECIFY_EDIT_ACTIVE_FORMULA_COMPLETE:
        break;
      case UI_SPECIFY_METHOD:
        break;
      case UI_SPECIFY_OPEN_CALCHEAD:
        break;
      case UI_SPECIFY_PROBLEM:
        break;
      case UI_SPECIFY_RESET:
        break;
      case UI_SPECIFY_SWITCH_TO_GUARD:
        break;
      case UI_SPECIFY_SWITCH_TO_MODEL:
        break;
      case UI_SPECIFY_THEORY:
        break;
      case UI_SPECIFY_TO_SOLVE:
        break;
      case UI_STOP_SESSION:
        break;
      default:
        break;
    }

    // *********** handle IUserAction's **********************

    switch (request) {
    // in solve-phase request open a CalcHead by context-menu
      /**
       * needed for TermTreePanel of context-menu test
       */
    case UI_SOLVE_TERM_TREE:
        //in the original code in Rlb - here manually set
        if(context_formula_!=null){
        switchToTermTree((CalcFormula)context_formula_);
        }
        break;
      case LO_EXAMPLE_FINISHED_SUCCESSFUL:
        break;
      case LO_OPEN_WORKSHEET:
        break;
      case LO_START_SESSION:
        break;
      case UI_ACTIVE_WORKSHEET:
        break;
      case UI_BROWSER_CHANGE_CONTEXT:
        break;
      case UI_BROWSER_EXECUTE_CONTEXT:
        break;
      case UI_BROWSER_GET_FOCUS:
        break;
      case UI_BROWSER_GOT_FOCUS:
        break;
      case UI_BROWSER_HIERARCHY:
        break;
      case UI_BROWSER_LOST_FOCUS:
        break;
      case UI_BROWSER_MATCH_OFF:
        break;
      case UI_BROWSER_MATCH_ON:
        break;
      case UI_BROWSER_TO_WORKSHEET:
        break;
      case UI_CLOSE_WORKSHEET:
        break;
      case UI_DO_ACTIVATE:
        break;
      case UI_DO_APPEND_FORMULA:
        break;
      case UI_DO_DEACTIVATE:
        break;
      case UI_DO_DETACH:
        break;
      case UI_DO_EDIT_FORMULA:
        break;
      case UI_DUMMY_FIRST_SOLVE:
        break;
      case UI_DUMMY_FIRST_SPECIFY:
        break;
      case UI_DUMMY_LAST_SOLVE:
        break;
      case UI_DUMMY_LAST_SPECIFY:
        break;
      case UI_MINIBROWSER_LINK:
        break;
      case UI_OPEN_BROWSER_FRAME:
        break;
      case UI_OPEN_WORKSHEET:
        break;
      case UI_PROBLEMBROWSER_REFINE:
        break;
      case UI_SHOW_EXAMPLE_BROWSER:
        break;
      case UI_SHOW_METHOD_BROWSER:
        break;
      case UI_SHOW_PROBLEM_BROWSER:
        break;
      case UI_SHOW_THEORY_BROWSER:
        break;
      case UI_SOLVE_APPEND_USER_FORMULA:
        break;
      case UI_SOLVE_CALCULATE_1:
        break;
      case UI_SOLVE_CALCULATE_ALL:
        break;
      case UI_SOLVE_CALCULATE_SUBPROBLEM:
        break;
      case UI_SOLVE_CHANGE_CONTEXT_FORMULA:
        //TODO?
        break;
      case UI_SOLVE_EDIT_ACTIVE_FORMULA:
        break;
      case UI_SOLVE_EDIT_ACTIVE_FORMULA_COMPLETE:
        break;
      case UI_SOLVE_GET_APPLICABLE_TACTICS:
        break;
      case UI_SOLVE_GET_PROPOSED_TACTIC:
        break;
      case UI_SOLVE_HELP_ENTERING_FORMULA:
        break;
      case UI_SOLVE_MOVE_ACTIVE_FORMULA:
        break;
      case UI_SOLVE_SET_NEXT_TACTIC:
        break;
      case UI_SOLVE_SHOW_APPLICABLE_TACTICS:
        break;
      case UI_SOLVE_SHOW_ASSUMPTIONS:
        break;
      case UI_SOLVE_SHOW_CALCHEAD:
        break;
      case UI_SOLVE_SHOW_INTERMEDIATE_STEPS:
        break;
      case UI_SOLVE_TACTIC_APPLIED:
        break;
      case UI_SPECIFY_CALCULATE_ALL:
        break;
      case UI_SPECIFY_CHANGE_VIEW:
        break;
      case UI_SPECIFY_CHECK_CALCHEAD:
        break;
      case UI_SPECIFY_CLOSE_CALCHEAD:
        break;
      case UI_SPECIFY_COMPLETE_CALCHEAD:
        break;
      case UI_SPECIFY_COMPLETE_FIND:
        break;
      case UI_SPECIFY_COMPLETE_GIVEN:
        break;
      case UI_SPECIFY_COMPLETE_MODEL:
        break;
      case UI_SPECIFY_COMPLETE_RELATE:
        break;
      case UI_SPECIFY_COMPLETE_STEPWISE:
        break;
      case UI_SPECIFY_EDIT_ACTIVE_FORMULA_COMPLETE:
        break;
      case UI_SPECIFY_METHOD:
        break;
      case UI_SPECIFY_OPEN_CALCHEAD:
        break;
      case UI_SPECIFY_PROBLEM:
        break;
      case UI_SPECIFY_RESET:
        break;
      case UI_SPECIFY_SWITCH_TO_GUARD:
        break;
      case UI_SPECIFY_SWITCH_TO_MODEL:
        break;
      case UI_SPECIFY_THEORY:
        break;
      case UI_SPECIFY_TO_SOLVE:
        break;
      case UI_STOP_SESSION:
        break;
      default:
        break;
     }
    return true;
    }

    @Override
    public void notifyGUIReady() {
        worksheet_ready_ = true;
    }

    @Override
    public boolean addDataChangeListener(IToUser listener) {
        if (datachange_listeners_.contains(listener)) {
            return false;
        } else {
            datachange_listeners_.add(listener);
        }
        return true;
    }

    @Override
    public ICalcIterator iterator(CalcIterator it, IWorksheetDialog dg) throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet."); 
    }

    @Override
    public String getWorksheetID() throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet."); 
    }
    
    private void buildUIElementsContextCalcElements() {
        try {
            ui_control_listener_.addUIElement(new UIAction(
                    EUIElement.UI_SOLVE_SHOW_ASSUMPTIONS,
                    EUIContext.UI_CONTEXT_CALCELEMENTS, user_language_));
            ui_control_listener_.addUIElement(new UIAction(
                    EUIElement.UI_SOLVE_TACTIC_APPLIED,
                    EUIContext.UI_CONTEXT_CALCELEMENTS, user_language_));
            ui_control_listener_.addUIElement(new UIAction(
                    EUIElement.UI_SOLVE_SHOW_INTERMEDIATE_STEPS,
                    EUIContext.UI_CONTEXT_CALCELEMENTS, user_language_));
            /**
             * part of TermTreePanel of context-menu test
             */
            ui_control_listener_.addUIElement(new UIAction(
                EUIElement.UI_SOLVE_TERM_TREE,
                EUIContext.UI_CONTEXT_CALCELEMENTS, user_language_));
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
    /*
     * Sending Formulas follows Isac's architecture as follows:
     * 1. The <code>MathEngine<\code> (<code>TestWorksheetForMawen</code>) knows a 
     *    <code>Position</code> of the <code>Formula</code> in the <code>CalcTree</code>
     * 2. sendFormulaToWorksheet sends this <code>Position</code> to the <code>(Mock)WorksheetDialog</code>
     * 3. The <code>(Mock)WorksheetDialog</code> uses calcResponse to pass this <code>Position</code>
     *    wrapped into a <code>CalcChanged</code> event
     * 4. The (original) <code>Worksheet</code> fetches the <code>Formula</code> by
     *    <code>(Mock)DialogIterator(SIMPLIFY).getFormulaeFromTo</code>
     * 5. The <code>MockDialogIteratorSIMPLIFY</code> fetches the <code>Formula</code> related to the
     *    <code>Position</code> in <code>MockCalcTreeSIMPLIFY</code>
     */
    protected void sendFormulaToWorksheet (Position from, Position to) {
      ICalcIterator i_from = new MockDialogIterator(from);
      ICalcIterator i_to = new MockDialogIterator(to);
      CalcChanged e = new CalcChanged(4711, false, i_from, i_from, i_to);
      try {
        ((IToUser) datachange_listeners_.elementAt(0)).calcResponse(e);
        context_formula_ =(CalcFormula) ((MockDialogIterator)e.getLastGeneratedFormula()).
            getFormula(to);
      } catch (RemoteException e1) {
        // TODO Auto-generated catch block
        e1.printStackTrace();
      }catch(Exception e2) {
        e2.printStackTrace();
      }
    } 
    /**
     * needed for TermTreePanel of context-menu test
     */
    public void switchToTermTree(CalcFormula cf) {
      try {
          doUIAction(new UIActionOnCalcElement(
            EUIElement.UI_SOLVE_TERM_TREE,
            EUIContext.UI_CONTEXT_ONEELEMENT, user_language_,
                      cf));
          //TODO still something wrong with this one?
       //   ui_control_listener_.addUIElement(new UIAction(
       //     EUIElement.UI_SOLVE_EDIT_ACTIVE_FORMULA,
       //     EUIContext.UI_CONTEXT_ONEELEMENT, user_language_));         
      } catch (RemoteException e) {
          e.printStackTrace();
      }
  }
    /**
     * needed for TermTreePanel of context-menu test
     */
    public synchronized void doUIAction(final IUIAction action)
        throws RemoteException {
    Thread t = new Thread(new Runnable() {

        public void run() {
            try {
                while (worksheet_ready_ == false) {
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e1) {
                        e1.printStackTrace();
                    }
                }
                ui_control_listener_.doUIAction(action);
            } catch (RemoteException e) {
                e.printStackTrace();
            }
        }
    });
    t.run();
}
}
