/*
 * @author Natalie Karl
 * Copyright (c) 2015 by Natalie Karl
 * FH Hagenberg, Software Engineering 
 * 
 * Use is subject to license terms.
 */
package isac.gui.mawen;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author Natalie Karl
 */
public class Testall extends TestCase {

  public static Test suite() {
	  System.out.println("/--BEGIN isac.gui.mawen.Testall");
	  TestSuite suite = new TestSuite("isac.gui.mawen.Testall");
		
	  //tests from subdirectories
	  suite.addTest(isac.gui.mawen.editor.Testall.suite());
	  suite.addTest(isac.gui.mawen.scalaterm.Testall.suite());
	  suite.addTest(isac.gui.mawen.syntax.Testall.suite());
	  
	  //tests in this directory
	  // MockCalTreeSIMPLIFY         ... is NOT a JUnit TestCase, mock
	  // MockDialogIteratorSIMPLIFY	 ... is NOT a JUnit TestCase, mock
	  // MockWorksheetDialog         ... is NOT a JUnit TestCase, mock
	  // TestDATA	                 ... is NOT a JUnit TestCase, data only
//WN160513 presently this works only in debug-mode:
//    suite.addTestSuite(isac.gui.mawen.TestTermTreeView.class);
      suite.addTestSuite(isac.gui.mawen.TestUseCases.class);
//WN160513 presently this works only in debug-mode:
//	  suite.addTestSuite(isac.gui.mawen.TestWorksheetForMawen.class); 
		
	  System.out.println("\\--END   isac.gui.mawen.Testall");
	  return suite;
	}
}