package isac.session;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/**
 *
 * @author Tom Zillinger
 */
public class TestLearningMode {
    
    @Test
    public void testLearningModeCorrect() {
        assertThat(LearningMode.isValidLearningMode("assessment"), is(true));
        assertThat(LearningMode.isValidLearningMode("assessment "), is(true));
        assertThat(LearningMode.isValidLearningMode("ASSESSMENT"), is(true));
        assertThat(LearningMode.isValidLearningMode(" learner "), is(true));
        assertThat(LearningMode.isValidLearningMode("LEARNER"), is(true));
    }
    
    @Test
    public void testLearningModeInCorrect() {
        assertThat(LearningMode.isValidLearningMode("other"), is(false));
    }    
}
