/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 1:33:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.wsdialog;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.wsdialog.Testall");
		TestSuite suite = new TestSuite("isac.wsdialog.Testall");
		
		//tests from subdirectories
		//..
		
		//tests in this directory
		//                               TestInitDialog      ... is NOT a JUnit TestCase
		//                               TestInitDialogNOrlb ... is NOT a JUnit TestCase
		//WN170211: runs as single TestCase, but subsequently causes errors in TestSolve:
		//suite.addTestSuite(isac.wsdialog.TestSimpleRLB.class);
		suite.addTestSuite(isac.wsdialog.TestSolve.class);
		suite.addTestSuite(isac.wsdialog.TestSolveEtc.class);
		//                               TestNextBtn         ... is NOT a JUnit TestCase
		
		System.out.println("\\--END   isac.wsdialog.Testall");
		return suite;
	}
	
	
	
}
