/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 18, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.bridge.xml;

import isac.util.formulae.Context;


public class IntContext {

    //private Integer calcid_; WN150530: calcid will be required for asynchronous communication *)
    private Context context_;
    
    /* WN150824: isabisac ... isac-java seems to incompatible:
     * isabisac/../interface-xml.xml_of_matchpbl is incompatible with
     * isac.util.parser.XMLParserDigest //=== Rules for parsing Contexts.
     * 
     * Unfortunately there is no use-case and no test for refineProblem,
     * so the Context only gets the KEStoreKey ("GUH"), 
     * not the HierarchyKey.
     */
    public IntContext(//Integer calcid, WN150530
    		Context context_) {
    	//calcid_ = calcid; WN150530
    	this.context_ = context_;
    }

// WN150530: calcid will be required for asynchronous communication *)
//    public Integer getCalcId() {
//        return calcid_;
//    }  
    public Context getContext() {
        return context_;
    }  

}
