/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 12, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.bridge.xml;

/**
 * compounds calcid and isac.util.formulae.Position
 * for transport from libisabelle/PIDE to isac-java.
 * @author Walther Neuper
 */
public class IntIntCompound {

    private Integer calcid_;
    private Integer userid_;

    public IntIntCompound(Integer calcid, Integer userid) {
    	calcid_ = calcid;
    	userid_ = userid;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public Integer getUserId() {
        return userid_;
    }  
}