/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.util.Message;

/**
 * Compounds calcid and isac.util.Message.
 * WN150721 preliminarily used for stubbing message handling in isac-java.
 * @author Walther Neuper
 */
public class IntMessage {

    private Integer calcid_;
    private Message message_;
    
    /* Constructor for conversion from XML */
    public IntMessage(Integer calcid, Message message) {
    	
    	calcid_ = calcid;
    	message_ = message;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public Message getMessage() {
        return message_;
    }  

}