package isac.gui.browser.minibrowser;

import javax.swing.text.ViewFactory;
import javax.swing.text.html.HTMLEditorKit;

public class MiniBrowserEditorKit extends HTMLEditorKit {
	
	static final long serialVersionUID = 6060488996010361897L;
	
	protected MiniBrowser parent_;
	
	protected MiniBrowserViewFactory  factory_; 
	 
	protected ContextRenderer context_renderer_;
	
	MiniBrowserEditorKit( MiniBrowser parent ) {
		super();
		parent_ = parent; 
		factory_ = new MiniBrowserViewFactory( parent_ );
	
		context_renderer_ = new ContextRenderer( parent_ );
	
		factory_.addElementPresenter( "context", context_renderer_ );
	}
	
	public ViewFactory getViewFactory()	{ 
		return factory_;
	} 

}
