package isac.session;

/**
 * This Exception occurs if the user/password is not known to ISAC.
 * @author tomzi
 */
public class AuthenticationException extends Exception {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
     * Creates a new instance of
     * <code>AuthenticationException</code> without detail message.
     */
    public AuthenticationException() {
    }

    /**
     * Constructs an instance of
     * <code>AuthenticationException</code> with the specified detail message.
     *
     * @param msg the detail message.
     */
    public AuthenticationException(String msg) {
        super(msg);
    }
}
