/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Jul 11, 2005 11:22:06 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.useractions;

import isac.interfaces.ICalcIterator;
import isac.users.UserLanguage;

/**
 * @author Alois Kirchsteiger
 *
 */
public class UIActionOnIterator extends UIAction {

    static final long serialVersionUID = 6766867529443444743L;
    
	ICalcIterator iterator_;

    public ICalcIterator getIterator() {
        return iterator_;
    }
    
    public UIActionOnIterator(EUIElement action, EUIContext context, UserLanguage ul, ICalcIterator iterator) {
        super(action, context, ul);
        iterator_ = iterator;
    }

}
