
package isac.useractions;

import isac.users.UserLanguage;
import isac.util.formulae.HierarchyKey;

/**
 * To send a HierarchyKey form Dialog to GUI
 * 
 * @author Johannes Loinig
 * @version $Revision: 1.5 $
 */
public class UIActionOnKeStoreID extends UIAction {

	static final long serialVersionUID = 1705068003330234055L;
	
	private HierarchyKey ke_store_id_;
	
	/**
	 * @param action
	 * @param context
	 */
	public UIActionOnKeStoreID(EUIElement action, EUIContext context, UserLanguage ul,
			HierarchyKey ke_store_id) {
		super(action, context, ul);
		ke_store_id_ = ke_store_id;
	}
	
	/**
	 * Returns the contining id.
	 * @return
	 */
	public HierarchyKey getKEStoreID() {
		return ke_store_id_;
	}

}
