package isac.useractions;

import isac.util.formulae.Position;

public class UserActionOnPosition extends UserAction {

	static final long serialVersionUID = 2772006076319562852L;
	
	Position position_;
	
	public UserActionOnPosition(EUIElement id) {
		super(id);
		position_ = null;
	}

	public UserActionOnPosition(EUIElement id, EUIContext context) {
		super(id, context);
		position_ = null;
	}

	public UserActionOnPosition(EUIElement id, EUIContext context, Position pos) {
		super(id, context);
		position_ = pos;
	}

	/**
	 * @return Returns the position_.
	 */
	public Position getPosition() {
		return position_;
	}

	/**
	 * @param position_ The position_ to set.
	 */
	public void setPosition(Position position) {
		position_ = position;
	}

}
