package isac.util;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class KEStorePaths {
    /**
     * RMI
     */
    public static String OBJECT_MANAGER_PATH = "";
    //	public static String OBJECT_MANAGER_PATH =
    // "//localhost/isac-ObjectManager";

    /**
     * WN060223 ?
     */
    public static Integer JAVA_SERVER_PORT = 0;
    //	public static Integer JAVA_SERVER_PORT = 1040;

    /**
     * WN060223 ?
     */
    public static Integer KESTORE_SERVER_PORT = 0;
    //	public static Integer KESTORE_SERVER_PORT = 1030;

    /**
     * FIXME.WN060223 "XML_DATA_PATH/pbl/PROBLEM_HIERARCHY_FILE_NAME" discard
     */
    public static String PROBLEM_HIERARCHY_FILE_NAME = "";
    //	public static String PROBLEM_HIERARCHY_FILE_NAME = "pbl_hierarchy.xml";

    /**
     * FIXME.WN060223 "XML_DATA_PATH/exp/EXAMPLE_HIERARCHY_FILE_NAME" discard
     */
    public static String EXAMPLE_HIERARCHY_FILE_NAME = "";
    //	public static String EXAMPLE_HIERARCHY_FILE_NAME = "exp_hierarchy.xml";

    /**
     * FIXME.WN060223 "XML_DATA_PATH/met/METHOD_HIERARCHY_FILE_NAME" discard
     */
    public static String METHOD_HIERARCHY_FILE_NAME = "";
    //	public static String METHOD_HIERARCHY_FILE_NAME = "met_hierarchy.xml";
    
    public static String THEORY_HIERARCHY_FILE_NAME = "";
    //	public static String THEORY_HIERARCHY_FILE_NAME = "met_hierarchy.xml";

    /**
     * stylesheets for javascript generating the hierarchy on the
     * standard-browser
     */
    public static String GENHTML_PATH = "";
    //	public static String GENHTML_PATH =
    // "/home/neuper/proto2/isac/src/java/isac/util/genhtml/";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/PROBLEM_HIERARCHY_JMENU_FILE_NAME"
     */
    public static String PROBLEM_HIERARCHY_JMENU_FILE_NAME = "";
    //	public static String PROBLEM_HIERARCHY_JMENU_FILE_NAME =
    // "pbl_hierarchy_jmenu.xsl";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/EXAMPLE_HIERARCHY_JMENU_FILE_NAME"
     */
    public static String EXAMPLE_HIERARCHY_JMENU_FILE_NAME = "";
    //	public static String EXAMPLE_HIERARCHY_JMENU_FILE_NAME =
    // "exp_hierarchy_jmenu.xsl";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/METHOD_HIERARCHY_JMENU_FILE_NAME"
     */
    public static String METHOD_HIERARCHY_JMENU_FILE_NAME = "";
    //	public static String METHOD_HIERARCHY_JMENU_FILE_NAME =
    // "met_hierarchy_jmenu.xsl";

    public static String THEORY_HIERARCHY_JMENU_FILE_NAME = "";
    //	public static String METHOD_HIERARCHY_JMENU_FILE_NAME =
    // "thy_hierarchy_jmenu.xsl";
    
    /**
     * the xml-files comprising 'the KEStore' (TODO replace by SQL-database)
     */
    public static String XML_DATA_PATH = "";
    //	public static String XML_DATA_PATH = "/home/johannes/isac/isac/xmldata/";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/PROBLEM_HCONTENT_FILE_NAME"
     */
    public static String PROBLEM_HCONTENT_FILE_NAME = "";
    //	public static String PROBLEM_HCONTENT_FILE_NAME = "pbl_hcontent.xsl";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/EXAMPLE_HCONTENT_FILE_NAME"
     */
    public static String EXAMPLE_HCONTENT_FILE_NAME = "";
    //	public static String EXAMPLE_HCONTENT_FILE_NAME = "exp_hcontent.xsl";

    /**
     * FIXME.WN060223 simplify
     * "GENHTML_PATH/templates/METHOD_HCONTENT_FILE_NAME"
     */
    public static String METHOD_HCONTENT_FILE_NAME = "";
    //	public static String METHOD_HCONTENT_FILE_NAME = "met_hcontent.xsl";

    public static String THEORY_HCONTENT_FILE_NAME = "";
    //	public static String METHOD_HCONTENT_FILE_NAME = "thy_hcontent.xsl";
    
    /**
     * where the to be generated html-files are written to
     */
    public static String GENHTML_DESTINATON_PATH = "";
    //	public static String GENHTML_DESTINATON_PATH =
    // "/home/neuper/proto2/www/kbase/";

    /**
     * logger over RMI modules
     */
    public static String LOG4J_PROPERTIES = "";
    //	public static String LOG4J_PROPERTIES =
    // "/home/johannes/isac/isac/src/java/log4j.properties";

    /**
     * check the number of args for main; return value SET MANUALLY,
     * be cautious !
     */
    public static int getNumConstants() {
        return 19;
    }

    public static void setConstants(String config_path) {

    	Properties p = new Properties();
    try{
    	p.load(new FileInputStream(config_path));
        OBJECT_MANAGER_PATH = readProperty(p,"OBJECT_MANAGER_PATH");
        JAVA_SERVER_PORT = Integer.valueOf(readProperty(p,"JAVA_SERVER_PORT"));
        KESTORE_SERVER_PORT = Integer.valueOf(readProperty(p,"KESTORE_SERVER_PORT"));
        PROBLEM_HIERARCHY_FILE_NAME = readProperty(p,"PROBLEM_HIERARCHY_FILE_NAME");
        EXAMPLE_HIERARCHY_FILE_NAME = readProperty(p,"EXAMPLE_HIERARCHY_FILE_NAME");
        METHOD_HIERARCHY_FILE_NAME = readProperty(p,"METHOD_HIERARCHY_FILE_NAME");
        THEORY_HIERARCHY_FILE_NAME = readProperty(p,"THEORY_HIERARCHY_FILE_NAME");
        GENHTML_PATH = readProperty(p,"GENHTML_PATH");
        PROBLEM_HIERARCHY_JMENU_FILE_NAME = readProperty(p,"PROBLEM_HIERARCHY_JMENU_FILE_NAME");
        EXAMPLE_HIERARCHY_JMENU_FILE_NAME = readProperty(p,"EXAMPLE_HIERARCHY_JMENU_FILE_NAME");
        METHOD_HIERARCHY_JMENU_FILE_NAME = readProperty(p,"METHOD_HIERARCHY_JMENU_FILE_NAME");
        THEORY_HIERARCHY_JMENU_FILE_NAME = readProperty(p,"THEORY_HIERARCHY_JMENU_FILE_NAME");
        XML_DATA_PATH = readProperty(p,"XML_DATA_PATH");
        PROBLEM_HCONTENT_FILE_NAME = readProperty(p,"PROBLEM_HCONTENT_FILE_NAME");
        EXAMPLE_HCONTENT_FILE_NAME = readProperty(p,"EXAMPLE_HCONTENT_FILE_NAME");
        METHOD_HCONTENT_FILE_NAME = readProperty(p,"METHOD_HCONTENT_FILE_NAME");
        THEORY_HCONTENT_FILE_NAME = readProperty(p,"THEORY_HCONTENT_FILE_NAME");       
        GENHTML_DESTINATON_PATH = readProperty(p,"GENHTML_DESTINATON_PATH");
        LOG4J_PROPERTIES = readProperty(p,"LOG4J_PROPERTIES");

    	
    } catch (FileNotFoundException e) {
        System.out.println("Couldn't open INI File");
        System.exit(1);
    } catch (IOException e) {
        System.out.println("Couldn't read INI File");
        System.exit(1);
    }

    }
    private static String readProperty(Properties p, String name){
    	String result = p.getProperty(name);
    	if(result == null){
        	System.out.println("No "+ name +" found in config file");
        	System.exit(1);
    	}
    	return result;
        
    }
}