/*
 * @author Georg Kompacher, member of the ISAC-team, 
 * Copyright (c) 2006 by Georg Kompacher
 * created 18.07.2006 09:06:49
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

public class FormulaPair {

	private Formula assumtion_;
	
	private Boolean value_; //WN150820 change to Formula !!!
	
	public FormulaPair(){}
	public FormulaPair(Formula assumtion, Boolean value){
		assumtion_ = assumtion;
		value_ = value;		
	}
	
	public Formula getAssumtion() {
		return assumtion_;
	}
	
	public Boolean getValue() { //WN150820 change to Formula !!!
		return value_;
	}
	
	public void setAssumtion(Formula assumtion) {
		assumtion_ = assumtion;
	}
	
	public void setValue(String value) {
		if(value.toLowerCase().compareTo("true") == 0)
		{
			value_ = true;
		}
		else
		{
			value_ = false;
		}
	}
	
	public void setValue(boolean value) {
		value_ = value;
	}
	
    public String toString() {
        return assumtion_.toString() + " = " + value_.toString();
    }
}
