package isac.util.genhtml;

import java.io.InputStream;
import java.util.Properties;

public class GenHTMLsinglePaths {

    static {
        loadPropertyFile();
    }

    public static void loadPropertyFile() {
        try {
            InputStream is = GenHTMLsinglePaths.class
                    .getResourceAsStream("/properties/GenHTMLsinglePaths.properties");
            if (is != null) {
                Properties p = new Properties();
                p.load(is);
                FILE_TO_CHECK = p.getProperty("FILE_TO_CHECK");
                GENHTML_DESTINATON_PATH = p.getProperty("GENHTML_DESTINATON_PATH");
            }
        } catch (Exception e) {
            FILE_TO_CHECK = "";
            e.printStackTrace();
        }
    }

    public static String FILE_TO_CHECK = "";

    public static String GENHTML_DESTINATON_PATH = "";

}