/*
 * @author Richard Gradischnegg
 * Created on Oct 10, 2003
 */
package isac.util.tactics;


/**
 * @author Richard Gradischnegg
 */
public class RewriteSetInst extends Tactic {
  
  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
String rule_set_;
  String variable_, value_; // repair for MathML: use term instead String 
  
  public RewriteSetInst() {}
  public RewriteSetInst(String name) {
    this.name_ = name;
  }
  public RewriteSetInst(String name, String rule_set, String variable, String value) {
	this.name_ = name;
	rule_set_ = rule_set;
	variable_ = variable;
	value_ = value;
  }

  public String getName() {
    return name_;
  }

  public String toSMLString() {
    return name_+" ([\"("+variable_+","+value_+")\"], \""+rule_set_+"\")";
  }
  
  
  /**
   * @return
   */
  public String getRuleSet() {
    return rule_set_;
  }

  /**
   * @return
   */
  public String getValue() {
    return value_;
  }

  /**
   * @return
   */
  public String getVariable() {
    return variable_;
  }

  /**
   * @param string
   */
  public void setRuleSet(String string) {
    rule_set_ = string;
  }

  /**
   * @param string
   */
  public void setValue(String string) {
    value_ = string;
  }

  /**
   * @param string
   */
  public void setVariable(String string) {
    variable_ = string;
  }

}
