/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 15, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.util.tactics;

/** ATTENTION: XML representation is faked in analogy to
 * RewriteInst, RewriteSetInst.
 * This will be changed at introduction of MathML.
 */
public class SubstituteTactic extends Tactic {

  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
String variable_, value_; // repair for MathML: use term instead String 

  public SubstituteTactic(String name, String variable, String value) {
	name_ = name;
	variable_ = variable;
	value_ = value;
  }

  public String getName() {
	    return name_;
	  }
  public String getVariable() {
	    return variable_;
	  }
  public String getValue() {
	    return value_;
	  }

}
