/*
 * @author Alan Krempler (method stubs)
 * Created on Sep 11, 2003
 */
package isac.util.tactics;

import isac.util.formulae.CalcElement;
import isac.util.formulae.Formula;
import java.util.Vector;

/**
 * @author Alan Krempler (method stubs) FIXME.WN0504 redesign this class wrt.
 *         inherited elements
 *
 * WN120728 quick and dirty addition of error_patterns_
 */
public class Tactic extends CalcElement {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected String name_;
    protected Vector<String> error_patterns_ = new Vector<String>();

    public String getName() {
        return name_;
    }

    public void setName(String name) {
        this.name_ = name;
    }

    public String getDescription() {
        return "";
    }

    /**
     * WN0504 put down in inheritance (valid only for some tacs)
     * 
     * WN080221 questionable if this should be due to inheritance
     * 
     * @see isac.util.tactics.Tactic#showToBeginner()
     */
    public String getTheoremName() {
        return "";
    }

    /**
     * WN0504 put down in inheritance (valid only for some tacs)
     * 
     * WN080221 questionable if this should be due to inheritance ...
     * 
     * @see isac.util.tactics.Tactic#showToBeginner()
     */
    public String getTheoremDescription() {
        return "";
    }

    /**
     * show the Formula contained in this Tactic
     * 
     * WN0504 put down in inheritance (valid only for some tacs)
     * 
     * WN080221 ...questionable if this should be due to inheritance ...
     * 
     * @see isac.util.tactics.Tactic#showToBeginner()
     */
    public Formula getTheoremSymbolic() {
        Formula dummy;
        dummy = new Formula();
        return dummy;
    }

    /**
     * show the Formula contained in this Tactic instantiated with form (makes
     * only sense, if this can be done within isacs java-part)
     * 
     * WN0504 put down in inheritance (valid only for some tacs)
     * 
     * WN080221 ...questionable if this should be due to inheritance ...
     * 
     * @see isac.util.tactics.Tactic#showToBeginner()
     */
    public Formula getTheoremInstantiated(Formula form) {
        Formula dummy;
        dummy = new Formula();
        return dummy;
    }

    /**
     * WN0504 put down in inheritance (valid only for some tacs) itself and
     * selected by passing an integer
     * 
     * WN080221 questionable if this should be due to inheritance ...
     * 
     * @see isac.util.tactics.Tactic#showToBeginner()
     */
    // 
    public Formula makeFillFormula(Formula formula, String pattern) {
        Formula dummy;
        dummy = new Formula();
        return dummy;
    }

    /**
     * (non-Javadoc)
     * 
     * @see isac.util.CalcElement#getText()
     */
    public String toSMLString() {
        return null; //... is (always?) overloaded: TODO redesign
    }

    /**
     * show the tactic to a beginner in a most simple form; 
     * 
     * WN080221 only implemented for rewrite-tacs
     */
    public String showToBeginner() {
        return this.toSMLString();
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.util.CalcElement#getMathML()
     */
    public String getMathML() {
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.util.CalcElement#getType()
     */
    public int getType() {
        return CALCEL_TACTIC;
    }

}