/*
 * Created on Nov 18, 2003
 */
package isac.wsdialog;

import isac.useractions.EUIElement;

/**
 * Exception thrown by the WorksheetDialog if the user action
 * indicated is not known to the WorksheetDialog.
 * 
 * @author Alan Krempler
 */
class DialogUnknownActionException extends DialogProtocolException {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	DialogUnknownActionException(EUIElement failed_action, int dialog_state) {
		super(failed_action, dialog_state, "\nThis request is unknown.", null);
	}

}
