/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 1:33:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.bridge.xml;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.bridge.xml.Testall");
		TestSuite suite = new TestSuite("isac.bridge.xml.Testall");
		
		//tests from subdirectories
		//..
		
		//tests in this directory
		suite.addTestSuite(isac.bridge.xml.TestDataTypes.class);
		suite.addTestSuite(isac.bridge.xml.TestXMLout.class);
		
        System.out.println("\\--END   isac.bridge.xml.Testall");
		return suite;
	}
	
	
	
}
