/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 28, 2004, 3:47:22 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.functest.specify;

import junit.framework.TestCase;

/**
 * TODO TestModel + input a completely new example
 * 
 * @author Walther Neuper Sep 28, 2004, 3:47:22 PM
 */
public class TestModel extends TestCase {

    /**
     * {\bf\UC{Editing the Model}\label{SPECIFY:enter}\label{SPECIFY:check}\\}
     * The user inpts items (i.e. adds formulae to the descriptions) to the
     * fileds 'given', 'find' and 'relate' and gets feedback fron \sisac{} on
     * each item with respect to the problem from the hidden specification. No
     * fields of the Specification will be changed.
     * 
     * @see isac.bridge.TestModel#testEditItems() for related methodcalls
     *      directly to the math-engine
     * @see {isac.util.formulae.TestCalcHead#testToSMLstring} for export
     * 		of a CalcHead to the stdin of SML
     */
    public void testEditItems() {
        System.out.println("---BEGIN isac.functest.TestModel#testEditItems");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out.println("---END isac.functest.TestModel#testEditItems");
    }

    /**
     * {\bf\UC{Having \isac{} Complete the
     * CalcHead}\label{SPECIFY:COMPLETE:all}\\} The user requests a CalcHead,
     * containing some input, to be completed automatically. WN0506 What kind of
     * messed input should be overwritten/corredted ???
     * 
     * @see isac.bridge.TestModel#testCompleteCalcHead() for related methodcalls
     *      directly to the math-engine
     */
    public void testCompleteCalcHead() {
        System.out
                .println("---BEGIN isac.functest.TestModel#testCompleteModel");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out.println("---END isac.functest.TestModel#testCompleteModel");
    }

    /**
     * The user requests the Model of a CalcHead, containing some input, to be
     * completed automatically. WN0506 What kind of messed input should be
     * overwritten/corredted ???
     * 
     * @see isac.bridge.TestModel#testCompleteModel() for related methodcalls
     *      directly to the math-engine
     */
    public void testCompleteModel() {
        System.out
                .println("---BEGIN isac.functest.TestModel#testCompleteModel");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out.println("---END isac.functest.TestModel#testCompleteModel");
    }

    /**
     * {\bf\UC{Having \isac{} Complete One Field of the
     * Model}\label{SPECIFY:COMPLETE:modelone}\\} When doing a prepared example,
     * the user can have one field of the Model completed by \isac{} with data
     * from the example collection.
     * 
     * @see isac.bridge.TestModel#testFillOneItem() for related methodcalls
     *      directly to the math-engine
     */
    public void testFillOneItem() {
        System.out.println("---BEGIN isac.functest.TestModel#testFillOneItem");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out.println("---END isac.functest.TestModel#testFillOneItem");
    }

}