/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 28, 2004, 3:37:02 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.functest.specify;

import junit.framework.TestCase;

/**
 * @see isac.bridge.TestSpecify for related tests
 */
public class TestSpecify extends TestCase {

    /**
     * {\bf\UC{Having \isac{} Complete the
     * Specification}\label{SPECIFY:COMPLETE:spec_}\\} When doing a prepared
     * example, the user can have the Specification completed by \isac{} with
     * data from the hidden specification.
     * 
     * @see isac.bridge.TestSpecify#testCompleteSpecification() for the related
     *      methodcalls in the bridge.
     */
    public void testCompleteSpecification() {
        System.out
                .println("---BEGIN isac.functest.TestSpecify#testCompleteSpecification");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out
                .println("---END isac.functest.TestSpecify#testCompleteSpecification");
    }

    /**
     * {\bf\UC{Having \isac{} Complete One Field of the
     * Specification}\label{SPECIFY:COMPLETE:specone}\\} The user can have one
     * field of the Specification (fields Theory, Problem, Method) completed by
     * \isac{} from data entered so far.
     * 
     * @see isac.bridge.TestSpecify#testCompleteOneFieldOfSpecification() for
     *      the related methodcalls in the bridge.
     */
    public void testCompleteOneFieldOfSpecification() {
        System.out
                .println("---BEGIN isac.functest.TestSpecify#testCompleteOneFieldOfSpecification");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out
                .println("---END isac.functest.TestSpecify#testCompleteOneFieldOfSpecification");
    }
}