/*
 * @author Walther Neuper
 * Copyright (c) 2004 by isac team
 * 
 * Use is subject to license terms.
 */
package isac.gui.browser;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 **/
public class Testall extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
		//WN041001 kam mit __________________ nicht zurecht
		TestRunner.run(Testall.class);
	}
	
	public static Test suite() {
		System.out.println("/--BEGIN isac.gui.browser.Testall");
		TestSuite suite = new TestSuite("isac.gui.browser.Testall");

		//tests in subdirectories
		suite.addTest(isac.gui.browser.minibrowser.Testall.suite());
		suite.addTest(isac.gui.browser.panels.Testall.suite());
		
		//tests in this directory
	    //...
		
	    System.out.println("\\--END   isac.gui.browser.Testall");
		return suite;
	}
}
