/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 2:01:07 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.kestore;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author Walther Neuper Sep 7, 2004, 2:01:07 PM
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.kestore.Testall");
		TestSuite suite = new TestSuite("isac.kestore.Testall");

		//tests in subdirectories
		//...
		
		//tests in this directory
		suite.addTestSuite(TestKEStoreServices.class);
		suite.addTestSuite(TestLoadContent.class);

		System.out.println("\\--END   isac.kestore.Testall");
		return suite;
	}
}

