/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Apr 13, 2005 3:46:18 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.session;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author neuper
 */
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.session.Testall");
		TestSuite suite = new TestSuite("isac.session.Testall");

		//tests in subdirectories
		//...
		
		//tests in this directory		
		suite.addTestSuite(TestDialogGuide.class);
		//                 TestLearningMode ... is NO JUnit TestCase
		suite.addTestSuite(TestUserManager.class);
		suite.addTestSuite(TestSessionManager.class);

		System.out.println("\\--END   isac.session.Testall");
		return suite;
	}
}
