/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 2:35:22 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author Walther Neuper Sep 7, 2004, 2:35:22 PM
 * @
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.util.Testall");
		TestSuite suite = new TestSuite("isac.util.Testall");
		
		//tests in subdirectories
		suite.addTest(isac.util.formulae.Testall.suite());
		//                      interfaces ... contains only Mocks
		suite.addTest(isac.util.parser.Testall.suite());
		suite.addTest(isac.util.tactics.Testall.suite());
		suite.addTest(isac.util.users.Testall.suite());
		
		//tests in this directory		
	    suite.addTestSuite(isac.util.TestCalcMessage.class);
	    //suite.addTestSuite(isac.util.TestKEStoreCommunication.class);
	    //...WN170211: this runs in isac.util.Testall, but NOT in isac.Testall

		System.out.println("\\--END   isac.util.Testall");
		return suite;
	}
}
