/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package isac.wsdialog;

import isac.interfaces.IToUser;
import isac.interfaces.IToGUI;
import isac.useractions.EUIContext;
import isac.useractions.IUIAction;
import isac.useractions.IUserAction;
import isac.util.CalcChanged;
import isac.util.CalcEvent;
import isac.util.CalcMessage;
import java.rmi.RemoteException;

/**
 * Mocks the WorksheetRMI for TestInitDialog*
 * 
 * @author Markus Kienleitner MKI
 */
public class MockWorksheetRMI implements IToUser, IToGUI {

  private CalcEvent event_;
  private IUIAction action_;

  @Override
  public void calcResponse(CalcEvent event) throws RemoteException {
    //System.err.println("----> CALC RESPONS");
    this.event_ = event;
  }

   @Override
   @Deprecated
    public boolean doUIAction(IUserAction action) throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void doUIAction(IUIAction action) throws RemoteException {
      //System.err.println("----> doUIAction: "+ action.getAction().name());
      this.action_ = action;
    }

    @Override
    public void addUIElement(IUIAction action) throws RemoteException {
        if (action.getContext() == EUIContext.UI_CONTEXT_WINDOW_APPLICATION) {
            //addToMenuBar(action);
        }
    }

    @Override
    public boolean removeUIElement(IUIAction action) throws RemoteException {
        if (action.getContext() == EUIContext.UI_CONTEXT_WINDOW_APPLICATION) {
            return true; //removeFromMenuBar(action);
        }
        return true;
    }

    @Override
    public boolean isUIRunning() throws RemoteException {
                return true;
    }
    
    /**
     * return a CalcChanged
     * 
     * @return 
     */
    public CalcChanged getCalcChanged()
    {
      return (CalcChanged)this.event_;
    }

    /**
     * return a CalcMessage
     * 
     * @return 
     */
    public CalcMessage getCalcMessage()
    {
      return (CalcMessage)this.event_;
    }
    
    /**
     * returns the doUIAction
     * 
     * @return 
     */
    public IUIAction getDoUIAction()
    {
     return this.action_; 
    }
}