package isac.bridge;

import info.hupel.isabelle.*;
import info.hupel.isabelle.api.XML;

public class IsacOperations {
	  // for Test_PIDE.java
	  public static final Operation<String, String> HELLO =
	    IsacOperationsScala.Hello();
	  
	  public static final Operation<String, String> TESTSTR =
			  IsacOperationsScala.Teststr();
	  
	  public static final Operation<scala.math.BigInt, XML.Tree> TESTIT =
	    IsacOperationsScala.Testit();
	  public static final Operation<XML.Tree, XML.Tree> TEST_TERM_TRANSFER =
		IsacOperationsScala.TestTermTransfer();
	  public static final Operation<String, XML.Tree> TEST_TERM_ONE_WAY =
		IsacOperationsScala.TestTermOneWay();
	  public static final Operation<String, XML.Tree> SCALATERM_OF_STRING =
		IsacOperationsScala.ScalaTermOfString();

	  // Protoco.thy operation_setup for all isabisac's Math_Engine --------
	  public static final Operation<XML.Tree, XML.Tree> APPEND_FORM =
	    IsacOperationsScala.appendFormula();
	  public static final Operation<XML.Tree, XML.Tree> AUTO_CALC =
	    IsacOperationsScala.autoCalculate();
	  public static final Operation<XML.Tree, XML.Tree> APPLY_TAC =
	    IsacOperationsScala.applyTactic();
	  public static final Operation<XML.Tree, XML.Tree> CALC_TREE =
	    IsacOperationsScala.CalcTree();
	  public static final Operation<XML.Tree, XML.Tree> CHECK_CTXT =
	    IsacOperationsScala.checkContext();
	  public static final Operation<scala.math.BigInt, XML.Tree> DEL_CALC =
	    IsacOperationsScala.DEconstrCalcTree();
	  public static final Operation<XML.Tree, XML.Tree> FETCH_APPL_TACS =
	    IsacOperationsScala.fetchApplicableTactics();
	  public static final Operation<XML.Tree, XML.Tree> FETCH_PROP_TAC =
	    IsacOperationsScala.fetchProposedTactic();
	  public static final Operation<XML.Tree, XML.Tree> FIND_FILL_PATTS =
	    IsacOperationsScala.findFillpatterns();
	  public static final Operation<XML.Tree, XML.Tree> GET_ACC_ASMS =
	    IsacOperationsScala.getAccumulatedAsms();
	  public static final Operation<XML.Tree, XML.Tree> GET_ACTIVE_FORM =
	    IsacOperationsScala.getActiveFormula();
	  public static final Operation<XML.Tree, XML.Tree> GET_ASMS =
	    IsacOperationsScala.getAssumptions();
	  public static final Operation<XML.Tree, XML.Tree> GET_FORMULAE =
	    IsacOperationsScala.getFormulaeFromTo();
	  public static final Operation<XML.Tree, XML.Tree> GET_TAC =
	    IsacOperationsScala.getTactic();
	  public static final Operation<XML.Tree, XML.Tree> INIT_CTXT =
	    IsacOperationsScala.initContext();
	  public static final Operation<XML.Tree, XML.Tree> INPUT_FILL_FORM =
	    IsacOperationsScala.inputFillFormula();
	  public static final Operation<XML.Tree, XML.Tree> INTER_STEPS =
	    IsacOperationsScala.interSteps();
	  public static final Operation<scala.math.BigInt, XML.Tree> ITERATOR =
	    IsacOperationsScala.Iterator();
	  public static final Operation<scala.math.BigInt, XML.Tree> MODEL_PBL =
	    IsacOperationsScala.modelProblem();
	  public static final Operation<XML.Tree, XML.Tree> MODIFY_CALCHEAD =
	    IsacOperationsScala.modifyCalcHead();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_CALCHEAD =
	    IsacOperationsScala.moveActiveCalcHead();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_DOWN =
	    IsacOperationsScala.moveActiveDown();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_FORM =
	    IsacOperationsScala.moveActiveFormula();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_LEVDN =
	    IsacOperationsScala.moveActiveLevelDown();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_LEVUP =
	    IsacOperationsScala.moveActiveLevelUp();
	  public static final Operation<scala.math.BigInt, XML.Tree> MOVE_ACTIVE_ROOT =
	    IsacOperationsScala.moveActiveRoot();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ACTIVE_UP =
	    IsacOperationsScala.moveActiveUp();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_CALCHEAD =
	    IsacOperationsScala.moveCalcHead();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_DOWN =
	    IsacOperationsScala.moveDown();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_LEVDN =
	    IsacOperationsScala.moveLevelDown();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_LEVUP =
	    IsacOperationsScala.moveLevelUp();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_ROOT =
	    IsacOperationsScala.moveRoot();
	  public static final Operation<XML.Tree, XML.Tree> MOVE_UP =
	    IsacOperationsScala.moveUp();
	  public static final Operation<XML.Tree, XML.Tree> REF_FORMULA =
	    IsacOperationsScala.refFormula();
	  public static final Operation<XML.Tree, XML.Tree> REFINE_PBL =
	    IsacOperationsScala.refineProblem();
	  public static final Operation<XML.Tree, XML.Tree> REPLACE_FORM =
	    IsacOperationsScala.replaceFormula();
	  public static final Operation<XML.Tree, XML.Tree> REQUEST_FILL_FORM =
	    IsacOperationsScala.requestFillformula();
	  public static final Operation<XML.Tree, XML.Tree> RESET_CALCHEAD =
	    IsacOperationsScala.resetCalcHead();
	  public static final Operation<XML.Tree, XML.Tree> SET_CTXT =
	    IsacOperationsScala.setContext();
	  public static final Operation<XML.Tree, XML.Tree> SET_MET =
	    IsacOperationsScala.setMethod();
	  public static final Operation<XML.Tree, XML.Tree> SET_NEXT_TAC =
	    IsacOperationsScala.setNextTactic();
	  public static final Operation<XML.Tree, XML.Tree> SET_PBL =
	    IsacOperationsScala.setProblem();
	  public static final Operation<XML.Tree, XML.Tree> SET_THY =
	    IsacOperationsScala.setTheory();


}
