/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 12, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.bridge.xml;

import isac.bridge.CChanged;


/**
 * compounds calcid and members of isac.bridge.CChanged
 * for transport from libisabelle/PIDE to isac-java.
 * @author Walther Neuper
 */
public class IntCChanged {

    private Integer calcid_;
    CChanged cc_;

    /* Constructor for conversion from XML */
    public IntCChanged(Integer calcid, CChanged cc) {
    	calcid_ = calcid;
    	cc_ = cc;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public CChanged getCChanged() {
        return cc_;
    }  
}