/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 1, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.util.formulae.Position;


/**
 * compounds calcid and members of isac.util.formulae.Position
 * for transport from libisabelle/PIDE to isac-java.
 * @author Walther Neuper
 */
public class IntPosition {

    private Integer calcid_;
    private Position pos_;

    /* Constructor for conversion from XML */
    public IntPosition(Integer calcid, Position pos) {
    	calcid_ = calcid;
    	pos_ = pos;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public Position getPosition() {
        return pos_;
    }  
}