/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 18, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.bridge.xml;

import isac.util.tactics.Tactic;

import java.util.Vector;

public class IntTacticErrPats {

    private Integer calcid_;
    private Vector<String> err_pats_;
    private Tactic tac_;
    
    /* Constructor for conversion from XML */
    public IntTacticErrPats(Integer calcid, Vector<String> err_pats, Tactic tac) {
    	calcid_ = calcid;
    	err_pats_ = err_pats;
    	tac_ = tac;
    }

    public Integer getCalcId() {
        return calcid_;
    }  
    public Vector<String> getCChanged() {
        return err_pats_;
    }  
    public Tactic getTactic() {
        return tac_;
    }  

}
