package isac.gui;

import java.rmi.RemoteException;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.Options;

/**
 *
 * @author Tom
 */
public class WindowApplicationWebStart extends WindowApplication {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public WindowApplicationWebStart() throws RemoteException {
        super();
    }
    
    public static void main(String[] args) throws RemoteException {
        System.out.println("Starting WindowApplicationWebStart...");
        Options options = createPossibleCommandLineOptions();
        CommandLine line = parseCommandLineOptions(options, args);
        WindowApplication.CommandLineValues commandLineValues = processCommandLineOptions(line, options);
        WindowApplicationWebStart windowApplication = new WindowApplicationWebStart();
        windowApplication.setCommandLineValues(commandLineValues);
        startApplication(windowApplication);
    }    
}
