package isac.gui.browser.minibrowser;

import isac.util.formulae.Context;
import isac.util.formulae.ContextUnknown;

import javax.swing.text.Element;
import javax.swing.text.View;

public class ContextRenderer implements IHTMLElementRenderer {

	protected MiniBrowser parent_;
	
	protected Context current_context_;
	
	public void contextChanged(Context new_context) {
		current_context_ = new_context;
	}

	public View renderElement(Element element) {
		current_context_ = parent_.getCurrentContext();
		
		if( current_context_ instanceof ContextUnknown )
			return null;
		
		return new ContextView( element, current_context_ );
	}

	public ContextRenderer( MiniBrowser parent ) {
		super();
		parent_ = parent;
	}

}
