package isac.gui.mawen.termtree;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JTree;



/**
 * This is the class for the tree representation of a formula, which 
 * can be accessed via context-menu of a formula. All GUI elements of the 
 * term tree must be accessible. 
 * 
 * This test is constructed under the model of <code>TestCalcheadView</code>.
 * 
 * @author NK 09052016
 **/
public class TermTreeView extends JPanel{
  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

public TermTreeFormPanel ttep_;
  
  public TermTreeRulePanel ttrp_;

  
  public JTree term_tree_;
  
  public TermTreeView(){
    initComponents();

  }
  
  public TermTreeView(JTree tree){
    term_tree_=tree;
    initComponents();
  }
  
  /*
   * Developed under the model of <code>TestCalcheadView.testShowCalchead()</code>
   */
  public void initComponents() {
    ttep_ = new TermTreeFormPanel(term_tree_);
    //should be optional (ViewStyle)
    ttrp_ = new TermTreeRulePanel();
    //moved should be optional (ViewStyle) tthp_ = new TermTreeHelpPanel();
    
    // moved to TTP dialog_.getContentPane().add(tthp_, BorderLayout.NORTH);
    this.add(ttep_, BorderLayout.WEST);
    this.add(ttrp_, BorderLayout.EAST);
    this.setSize(600, 300);
    this.setVisible(true);
   }
  }