package isac.useractions;

import isac.browserdialog.IBrowserDialog;
import isac.users.UserLanguage;

public class UIActionOnBrowserDialog extends UIAction {

	static final long serialVersionUID = -3276579420017707545L;

	protected IBrowserDialog	browser_dialog_;
	
	protected String		    frame_name_;
	
	public UIActionOnBrowserDialog(EUIElement action, EUIContext context, UserLanguage ul, IBrowserDialog browser_dialog,
			String frame_name ) {
		super(action, context, ul);
		browser_dialog_ = browser_dialog;
		
		frame_name_ = frame_name;
	}

	/**
	 * @return Returns the browser_dialog_.
	 */
	public IBrowserDialog getBrowserDialog() {
		return browser_dialog_;
	}


	/**
	 * @return Returns the frame_name_.
	 */
	public String getFrameName() {
		return frame_name_;
	}


}
