package isac.util;


/**
 *
 * @author tzilling@sbox.tugraz.at
 */
public final class StringUtils {

    /**
     * Returns defaultStr if str == null or "", otherwise str.
     */
    public static String defaultIfNull(String str, String defaultStr) {
        return (str == null || str.isEmpty()) ? defaultStr : str;
    }

    private StringUtils() {
    }

    /**
     * Return an empty String if {@code str} == null.
     */
    public static String emptyStringIfNull(String str) {
        return str == null ? "" : str;
    }
}
