/*
 * @author Alan Krempler
 * Created on Sep 11, 2003
 *  
 */
package isac.util.formulae;

/**
 * @author Alan Krempler (method stubs)
 *  
 */
public class CalcFormula extends Formula {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Position position_;

    public CalcFormula(){}

    public CalcFormula(Position pos, Formula form){
  	  position_ = pos;
      super.math_text_ = form.toString();
      super.term_ = form.getTerm();
    }
    
    public Position getPosition() {
        return position_;
    }
    public Formula getFormula() {
        return new Formula(super.math_text_, super.term_);
    }

    public void setPosition(Position position) {
        this.position_ = position;
    }

    //for XMLParserDigest
    public void setResponse(Position position) {
        this.position_ = position;
    }

    public void setFormula(Formula formula) {
        super.math_text_ = formula.math_text_;
        super.term_ = formula.getTerm();
   }

}