/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 15, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.util.tactics;


/** Tactics which take one Formula as argument.
 * This will be changed at introduction of MathML.
 */
public class TermTactic extends Tactic  {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected String/*Term*/ form_;
	
    public TermTactic(String name, String/*Term*/ form) {
        name_ = name;
        form_ = form;
      }
	
    public String getName() {
        return name_;
	  }
    public String/*Term*/ getTerm() {
        return form_;
    }
    public String toSMLString() {
        return name_ + " " + form_;
      }

}
