/*
 * Created on Feb 12, 2004
 *
 */

package isac.wsdialog;

import isac.useractions.EUIElement;

/**
 * Exception thrown by the WorksheetDialog if the user action
 * indicated caused an error in the math engine.
 * 
 * @author Alan Krempler
 *
 */
class DialogMathException extends DialogProtocolException {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	DialogMathException(EUIElement failed_action, int dialog_state, Throwable cause) {
		super(failed_action, dialog_state, "\nThis exception originates from the MathEngine.", cause);
	}
}

