/*
 * Created on Nov 18, 2003
 */
 
package isac.wsdialog;

import isac.useractions.EUIElement;

/**
 * Exception thrown by the WorksheetDialog if the action requested by the user
 * is known to the WorksheetDialog but not implemented yet.
 * 
 * @author Alan Krempler
 */
class DialogNotImplementedException extends DialogProtocolException {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected EUIElement failed_action_;
	
	DialogNotImplementedException(EUIElement failed_action, int dialog_state) {
		super(failed_action, dialog_state, "\nProcessing this request is not implemented yet.", null);
	}
}
